#!/bin/bash

export PATH=`pwd`/depot_tools:"$PATH"

# https://github.com/prahladyeri/tuxdrive/issues/3
apt-get install python3-pip -y
pip3 install httplib2 --upgrade

fetch v8
#gclient sync -r 6.9.427.6  # 55da769bafac8b531cd8b388df56161b8b7c6416
#gclient sync -r 7.1.69     #
#gclient sync -r lkgr/6.9
#gclient sync -r 6.9.427.13 # https://ci.appveyor.com/project/pmed/v8pp
cd v8
gclient sync -r 7.5.288.23  # https://github.com/pmed/v8-nuget/
# old version
# git checkout 5.5.372.7

# Looks like we have to use GN now: https://github.com/v8/v8/wiki/Building-with-GN

# initial build
./tools/dev/gm.py x64.release

# workaround, see notes.txt
echo "v8_enable_embedded_builtins = false"  | tee -a out/x64.release/args.gn
echo "v8_use_external_startup_data = false" | tee -a out/x64.release/args.gn
echo "v8_use_snapshot = false"              | tee -a out/x64.release/args.gn
echo "use_custom_libcxx = false"            | tee -a out/x64.release/args.gn
# possibly they use a different version of clang compiling v8.
# however, I already set my own, probably newer clang version.
# ran into: https://groups.google.com/forum/#!topic/v8-users/Jb1VSouy2Z0
echo "is_clang = false"                     | tee -a out/x64.release/args.gn


# produce monolith (single static all in one .a file)
echo "v8_monolithic = true"                 | tee -a out/x64.release/args.gn
ninja -C out/x64.release v8_monolith

# produce .so files (shared libs)
sed -i.bak '/^v8_monolithic/d' out/x64.release/args.gn
echo "is_component_build = true"            | tee -a out/x64.release/args.gn
ninja -C out/x64.release
